



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>PureMVC(JS版）源码解析（十）：Controller类</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">PureMVC(JS版）源码解析（十）：Controller类</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 16:52:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--?xml version="1.0" encoding="UTF-8" standalone="no"?--> &nbsp; &nbsp; &nbsp; 这篇博客我们继续讲解PureMVC的三大核心类(View/Controller/Model)&mdash;&mdash;Controller类。根据PureMVC模块设计，Controller类保存所有的Command映射，它的构造函数和工厂函数与View类的很相似：</p>
<div>
<pre class="prettyprint linenums">function Controller(key)<br />
{<br />
    if(Controller.instanceMap[key] != null)<br />
    {<br />
        throw new Error(Controller.MULTITON_MSG);<br />
    }

    this.multitonKey= key;<br />
    Controller.instanceMap[this.multitonKey]= this;<br />
    this.commandMap= new Array();<br />
    this.initializeController();<br />
}</pre>
</div>
<p>Controller构造函数中调用了initializeController()方法,它是用来初始化Controller对象。</p>
<div>
<pre class="prettyprint linenums">Controller.prototype.initializeController= function()<br />
{<br />
    this.view= View.getInstance(this.multitonKey);<br />
};</pre>
</div>
<p>initializeController()方法主要是为view属性赋值，方便调用View类的一些方法。</p>
<p>Controller类相对于View类的mediatorMap属性，它有一个commandMap属性，用来保存所有的Command映射，实际上所谓的映射就是一个notification对象和Command类关联在一起，形成key-value组合形式，存放在commandMap中。</p>
<p><!--?xml version="1.0" encoding="UTF-8" standalone="no"?--> 那在Controller类是怎么把notification对象和Command类关联在一起的呢？它提供了一个registerCommand方法。</p>
<div>
<pre class="prettyprint linenums">Controller.prototype.registerCommand= function(notificationName, commandClassRef)<br />
{<br />
    if(this.commandMap[notificationName] == null)<br />
    {<br />
        this.view.registerObserver(notificationName, new Observer(this.executeCommand, this));<br />
    }

    this.commandMap[notificationName]= commandClassRef;<br />
};</pre>
</div>
<p>这个函数就调用了view类的registerObserver方法，通过registerObserver方法的参数，我们可以知道，当Model类接受到消息会调用executeCommand()方法，我们看看executeCommand()方法执行了哪些操作：</p>
<div>
<pre class="prettyprint linenums">Controller.prototype.executeCommand= function(note)<br />
{<br />
    var commandClassRef= this.commandMap[note.getName()];<br />
    if(commandClassRef == null)<br />
        return;<br />
   //实例化一个Command对象（SimpleCommand或者MacroCommand)<br />
    var commandInstance= new commandClassRef();<br />
    commandInstance.initializeNotifier(this.multitonKey);<br />
    //执行Command的execute方法<br />
    commandInstance.execute(note);<br />
};</pre>
</div>
<p>executeCommand()方法告诉我们，<!--?xml version="1.0" encoding="UTF-8" standalone="no"?--> Command对象（SimpleCommand或者MacroCommand)是无状态的；只有在需要的时候（Controller收到相应的Notification）才会被创建，并且被执行（调用execute方法)。</p>
<p>Controller类还有removeCommand()/hasCommand()/removeController等方法，这些方法都很简单，建议读者自己阅读源代码，加深印象。</p>
<p>最后，附一张Controller类的思维导图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/474059/201310/14191956-646c4fc9df0c4104b989ee75bde10ecc.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2k6gwq.html">对 Visual Studio 中的Resharper禁用对某种文件的检测</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kz6668.html">0525 Scrum 项目7&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2l6539.html">mysql 日期类型比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p4m2y9.html">Django 基础教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x2z7m8.html">JavaScript 语法陷阱</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1p7gj8.html">VS2008下编译boost&lowbar;1&lowbar;47&lowbar;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zgk5j9.html">Excel连接到MySQL，将Excel数据导入MySql，MySQL for Excel，，</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv12njxq.html">SpringMVC之 数据绑定-1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge30ge8.html">more分页阅读</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj5yz19.html">回车键搜索 - Enter搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myv0j8.html">【Android Developers Training】 103&period; 查询当前地点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg6x3m8.html">JavaScript  new Boolean&lpar;false&rpar; 其实是true</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzdmee8.html">Learning Scrapy 中文版翻译  第一章</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megdg2q.html">电脑浅色显示器不显示怎么办，如何用PS去除logo底色</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ew4oq.html">&amp;lt&semi;Dare To Dream&amp;gt&semi; 第四次作业：基于原型的团队项目需求调研与分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rryx39.html">C&plus;&plus; Opencv split&lpar;&rpar;通道分离函数  merge&lpar;&rpar;通道合并函数  使用操作详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jjl0q.html">RPC理论以及Dubbo的使用介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4jmdj9.html">python基础一 ------如何获取多个字典相同的键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjzexl9.html">C&num; 使用事务transaction</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdven09.html">简单的SpringWebFlow例子及遇到的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z122019.html">bzoj 3527&colon; &lbrack;Zjoi2014&rsqb;力 快速傅里叶变换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjy6ed9.html">Discuz&excl;X3&period;1 全新安装图文教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1znxx59.html">http&colon;&sol;&sol;jinnianshilongnian&period;iteye&period;com&sol;blog&sol;2018936</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnrg0e8.html">通过live555实现H264 RTSP直播</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z12nxn9.html">MySQL查询原理及其慢查询优化案例分享&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z12npn9.html">Google 发布 Android 性能优化典范</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0ro14q.html">Lua table pair和ipair区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdegpz8.html">Android读取url图片保存及文件读取</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z12zzd9.html">【HDOJ】3047 Zjnu Stadium</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm24ve9.html">Oracle core03&lowbar;ACID</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
